<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfNumberDatetimePair ArrayType
 * @subpackage Arrays
 */
class ArrayOfNumberDatetimePair extends AbstractStructArrayBase
{
    /**
     * The NumberDatetimePair
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\NumberDatetimePair[]
     */
    public $NumberDatetimePair;
    /**
     * Constructor method for ArrayOfNumberDatetimePair
     * @uses ArrayOfNumberDatetimePair::setNumberDatetimePair()
     * @param \CustomerManagement\StructType\NumberDatetimePair[] $numberDatetimePair
     */
    public function __construct(array $numberDatetimePair = array())
    {
        $this
            ->setNumberDatetimePair($numberDatetimePair);
    }
    /**
     * Get NumberDatetimePair value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\NumberDatetimePair[]|null
     */
    public function getNumberDatetimePair()
    {
        return isset($this->NumberDatetimePair) ? $this->NumberDatetimePair : null;
    }
    /**
     * This method is responsible for validating the values passed to the setNumberDatetimePair method
     * This method is willingly generated in order to preserve the one-line inline validation within the setNumberDatetimePair method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateNumberDatetimePairForArrayConstraintsFromSetNumberDatetimePair(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfNumberDatetimePairNumberDatetimePairItem) {
            // validation for constraint: itemType
            if (!$arrayOfNumberDatetimePairNumberDatetimePairItem instanceof \CustomerManagement\StructType\NumberDatetimePair) {
                $invalidValues[] = is_object($arrayOfNumberDatetimePairNumberDatetimePairItem) ? get_class($arrayOfNumberDatetimePairNumberDatetimePairItem) : sprintf('%s(%s)', gettype($arrayOfNumberDatetimePairNumberDatetimePairItem), var_export($arrayOfNumberDatetimePairNumberDatetimePairItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The NumberDatetimePair property can only contain items of type \CustomerManagement\StructType\NumberDatetimePair, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set NumberDatetimePair value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\NumberDatetimePair[] $numberDatetimePair
     * @return \CustomerManagement\ArrayType\ArrayOfNumberDatetimePair
     */
    public function setNumberDatetimePair(array $numberDatetimePair = array())
    {
        // validation for constraint: array
        if ('' !== ($numberDatetimePairArrayErrorMessage = self::validateNumberDatetimePairForArrayConstraintsFromSetNumberDatetimePair($numberDatetimePair))) {
            throw new \InvalidArgumentException($numberDatetimePairArrayErrorMessage, __LINE__);
        }
        if (is_null($numberDatetimePair) || (is_array($numberDatetimePair) && empty($numberDatetimePair))) {
            unset($this->NumberDatetimePair);
        } else {
            $this->NumberDatetimePair = $numberDatetimePair;
        }
        return $this;
    }
    /**
     * Add item to NumberDatetimePair value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\NumberDatetimePair $item
     * @return \CustomerManagement\ArrayType\ArrayOfNumberDatetimePair
     */
    public function addToNumberDatetimePair(\CustomerManagement\StructType\NumberDatetimePair $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\NumberDatetimePair) {
            throw new \InvalidArgumentException(sprintf('The NumberDatetimePair property can only contain items of type \CustomerManagement\StructType\NumberDatetimePair, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->NumberDatetimePair[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\NumberDatetimePair|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\NumberDatetimePair|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\NumberDatetimePair|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\NumberDatetimePair|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\NumberDatetimePair|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string NumberDatetimePair
     */
    public function getAttributeName()
    {
        return 'NumberDatetimePair';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\ArrayType\ArrayOfNumberDatetimePair
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
